package com.kewley.aws.lambda.recurrence.service;

import com.kewley.aws.lambda.recurrence.dto.RecurrenceRequestDTO;
import com.kewley.aws.lambda.recurrence.dto.RecurringEventDTO;
import com.kewley.aws.lambda.recurrence.dto.RecurringEventDTOFactory;
import org.dmfs.rfc5545.DateTime;
import org.dmfs.rfc5545.recur.InvalidRecurrenceRuleException;
import org.dmfs.rfc5545.recur.RecurrenceRule;
import org.dmfs.rfc5545.recur.RecurrenceRuleIterator;

import java.time.Instant;
import java.time.LocalTime;
import java.time.ZoneId;
import java.time.ZoneOffset;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Handles creating {@link RecurringEventDTO}s from a given {@link RecurrenceRequestDTO}.
 */
public class RecurrenceRuleService {

    private final NowService nowService;
    private final int maxOccurrences;

    /**
     * @param maxOccurrences - The max number of recurring events that can be generated
     * @param nowService     - Service abstracted for easier testing, handles retrieving the current time stamp
     */
    public RecurrenceRuleService(int maxOccurrences, NowService nowService) {
        this.maxOccurrences = maxOccurrences;
        this.nowService = nowService;
    }

    /**
     * Responsible for generating recurring events given a valid rule.
     *
     * @param recurrenceRequestDTO - The request object which holds onto the rule data
     * @return A collection of recurring events generated by the rule.
     */
    public List<RecurringEventDTO> generateRecurringEventsFromRequest(RecurrenceRequestDTO recurrenceRequestDTO) {
        final String recurrenceRule = recurrenceRequestDTO.getRecurrenceRule();
        final String dateStartRule = recurrenceRequestDTO.getDateStartRule();
        final String dateEndRule = recurrenceRequestDTO.getDateEndRule();
        final Instant instant = Instant.now();
        final ZoneId systemZone = ZoneId.of(recurrenceRequestDTO.getTimezone());
        final ZoneOffset offset = systemZone.getRules().getOffset(instant);

        // determine the start/stop dates
        DateTime start = determineDateStart(dateStartRule, offset);
        DateTime end = determineDateEnd(start, dateEndRule, offset);

        // determine the time range
        LocalTime startTime = LocalTime.of(start.getHours(), start.getMinutes(), start.getSeconds());
        LocalTime endTime = LocalTime.of(end.getHours(), end.getMinutes(), end.getSeconds());

        // create the recurring events from the rule
        List<RecurringEventDTO> recurringUserEvents = generateRecurringEventsFromRule(recurrenceRule, offset, start, startTime, endTime);

        // sort by start time
        return recurringUserEvents.stream()
                .sorted(Comparator.comparing(RecurringEventDTO::getStartTimeMillis))
                .collect(Collectors.toList());
    }

    /**
     * Will retrieve the start date with it's respective zone from the {@code dateStartRule}.
     *
     * @param dateStartRule - A string rule of the form {@code "DTSTART=20180101T00:00"} or empty.
     * @param offset        - A valid offset
     * @return The start date which will either be now or determined by the {@code dateStartRule}
     */
    private DateTime determineDateStart(String dateStartRule, ZoneOffset offset) {
        DateTime start;
        if (dateStartRule == null || dateStartRule.trim().length() == 0) {
            start = nowService.determineNow(offset).startOfDay();
        } else {
            start = determineDateTimeFromString(dateStartRule, offset);
        }
        return start;
    }

    /**
     * Will determine the end date from the {@code start} and {@code dateEndRule}. If {@code dateEndRule} is
     * empty, the {@code start} will be used.
     *
     * @param start       - The start date that was determined from {@link #determineDateStart(String, ZoneOffset)}
     * @param dateEndRule - A string rule of the form {@code "DTEND=20180101T00:00"} or empty.
     * @param offset      - A valid offset
     * @return The end date
     */
    private DateTime determineDateEnd(DateTime start, String dateEndRule, ZoneOffset offset) {
        DateTime end;
        if (dateEndRule == null || dateEndRule.trim().length() == 0) {
            end = start;
        } else {
            end = determineDateTimeFromString(dateEndRule, offset);
        }
        return end;
    }

    /**
     * Will retrieve an {@link DateTime} object from a given {@code val}
     *
     * @param val    - A time value of the form {@code "DTSTART=YYYYMMddTHH:mm}"
     * @param offset - A valid offset
     * @return The {@code val} as an {@link DateTime}
     */
    private DateTime determineDateTimeFromString(String val, ZoneOffset offset) {
        final String[] parts = val.split("=");
        return DateTime.parse(offset.getId(), parts[1]);
    }

    /**
     * Will create a collection of {@link RecurringEventDTO}s from a VALID {@code recurrenceRule}.
     *
     * @param recurrenceRule - A valid {@link RecurrenceRule} as a string
     * @param zoneOffset     - The zone offset for the recurring events that are being created
     * @param start          - The start date for the {@link RecurrenceRuleIterator}
     * @param startTime      - The start time for each {@link RecurringEventDTO} (e.g. 09:00)
     * @param endTime        - The end time for each {@link RecurringEventDTO} (e.g. 11:00)
     * @return {@link List<RecurringEventDTO>} a collection of events evaluated,
     * empty events if {@code recurrenceRule} is invaid.
     */
    private List<RecurringEventDTO> generateRecurringEventsFromRule(String recurrenceRule, ZoneOffset zoneOffset, DateTime start, LocalTime startTime, LocalTime endTime) {
        List<RecurringEventDTO> recurringUserEvents = new ArrayList<>();
        int count = 0;
        try {
            RecurrenceRule rule = new RecurrenceRule(recurrenceRule);
            RecurrenceRuleIterator it = rule.iterator(start.getTimestamp(), start.getTimeZone());
            while (it.hasNext() && count <= maxOccurrences) {
                recurringUserEvents.add(RecurringEventDTOFactory
                        .createRecurringEventDTOFromMillisAndTime(it.nextDateTime().getTimestamp(), startTime, endTime, zoneOffset)
                );
                count++;
            }
        } catch (InvalidRecurrenceRuleException e) {
            recurringUserEvents = Collections.singletonList(RecurringEventDTO.builder().build());
        }
        return recurringUserEvents;
    }

}
